/* 
   A function for expanding the memory allocated for each dataset.


   What needs to be passed:

   char extstr - A string of the text to be formatted

   Basic usage:

   #include "allocate.c"

   ...

   chomp(anystring);

   Where anystring is a previously defined string. 

   If you have any question please email Jeremy.Harwood@physics.org and I will try and answer them as soon as I can.

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int allocate(int *xdim, int *ydim, float *bmaj, float *bmin, float *beamarea, int *imgnum, float **frequency, int numdatasets, int currentset, int *arraysallocated) {

  int i, j, *tmp_xdim, *tmp_ydim, *tmp_imgnum;
  float **tmp_frequency, *tmp_bmaj, *tmp_bmin, *tmp_beamarea, tmp_imgbuff, tmp_bgbuff;

  int totalsize = 0;

  printf("*** Arrays allocated (inside 1): %d ***\n", *arraysallocated);

 // Reallocate the memory
  /*
  if (currentset >= *arraysallocated) {

    totalsize = (*arraysallocated+1);

    printf("*** Total Size: %d ***\n", totalsize);

    xdim = (int *)realloc(xdim, totalsize * sizeof(int));
    ydim = (int *)realloc(ydim, totalsize * sizeof(int));
    bmaj = (float *)realloc(bmaj, totalsize * sizeof(float));
    bmin = (float *)realloc(bmin, totalsize * sizeof(float));
    beamarea = (float *)realloc(beamarea, totalsize * sizeof(float));
    imgnum = (int *)realloc(imgnum, totalsize * sizeof(int));

  // This needs to be accounted for at some point!!!

  //frequency = (float **)realloc(frequency, currentset * sizeof(float *));


  // For some reason ++ doesnt work here...
  *arraysallocated += 1;

  printf("*** Arrays allocated (inside 2): %d ***\n", *arraysallocated);


  // Set all the new values to 0
  //This needs sorting to set allocated memory to 0
  
  memset(xdim + (numdatasets * sizeof(int)), 0, (totalsize * sizeof(int)) - ((totalsize-1) * sizeof(int)) );
  memset(ydim + (numdatasets * sizeof(int)), 0, (totalsize * sizeof(int)) - ((totalsize-1) * sizeof(int)) );
  memset(bmaj + (numdatasets * sizeof(float)), 0, (totalsize * sizeof(float)) - ((totalsize-1) * sizeof(float)) );
  memset(bmin + (numdatasets * sizeof(float)), 0, (totalsize * sizeof(float)) - ((totalsize-1) * sizeof(float)) );
  memset(beamarea + (numdatasets * sizeof(float)), 0, (totalsize * sizeof(float)) - ((totalsize-1) * sizeof(float)) );
  memset(imgnum + (numdatasets * sizeof(int)), 0, (totalsize * sizeof(int)) - ((totalsize-1) * sizeof(int)) );
 

  }

  else {
    printf("This memory Has already been allocated. Should probably clean this up before proceeeding!");	
  }
  */

 

  //***imgbuff = (float ***)realloc(***imgbuff, numdatasets+1 * sizeof(float **));
  //***bgbuff = (float ***)realloc(***bgbuff, numdatasets+1 * sizeof(float **));








  
  // Allocate memory if this is the first time a dataset is to be loaded
  // Remember, the dataset number is numdatasets-1

  // Allocate memory to the temporary pointers


  totalsize = (*arraysallocated+2);


  tmp_xdim = (int *)calloc((totalsize),sizeof(int));
  tmp_ydim = (int *)calloc((totalsize),sizeof(int));
  tmp_bmaj = (float *)calloc((totalsize),sizeof(float));
  tmp_bmin = (float *)calloc((totalsize),sizeof(float));
  tmp_beamarea = (float *)calloc((totalsize),sizeof(float));
  tmp_imgnum = (int *)calloc((totalsize),sizeof(int));

  tmp_frequency = (float **)calloc((totalsize),sizeof(float *));
  /*
  for(i=0;i<=(totalsize);i++) {
    tmp_frequency[i] = (float *)calloc((totalsize),sizeof(float));
    }*/
 
  //printf("2\n");

  // Copy the values to the temporary arrays
  for(i=0;i<(totalsize-1);i++) {
    /*
      xdim[i] = 512;
      ydim[i] = 512;
      bmaj[i] = 5.12;
      bmin[i] = 5.12;
      beamarea[i] =  53.24;
      imgnum[i] = 7;
  */

    tmp_xdim[i] = xdim[i];
    tmp_ydim[i] = ydim[i];
    tmp_bmaj[i] = bmaj[i];
    tmp_bmin[i] = bmin[i];
    tmp_beamarea[i] = beamarea[i];
    tmp_imgnum[i] = imgnum[i];
    /*
    for(j=0;j<=imgnum[i];j++) {

      tmp_frequency[i][j] = frequency[i][j];

    }
    */
  }
 
 
 
  //printf("4\n");
  
  // Clear the old array values

  //for(i=0;i<totalsize;i++) {
    /*
    for(j=0;j<=imgnum[i];j++) {
      free(frequency[i]);
    }
    */
    free(xdim);
    free(ydim);
    free(bmaj);
    free(bmin);
    free(beamarea);
    free(imgnum);
    //    free(frequency);
    //}
  

  // Allocate the new array size memory

  //xdim = (int*)realloc(xdim, numdatasets+1*sizeof(

  //xdim = NULL;
  
    xdim = (int *)calloc(totalsize,sizeof(int));
    ydim = (int *)calloc(totalsize,sizeof(int));
    bmaj = (float *)calloc(totalsize,sizeof(float));
    bmin = (float *)calloc(totalsize,sizeof(float));
    beamarea = (float *)calloc(totalsize,sizeof(float));
    imgnum = (int *)calloc(totalsize,sizeof(int));
	
    //frequency = (float **)calloc(totalsize,sizeof(float *));
  

  // Copy back the values to the main array

  for(i=0;i<numdatasets;i++) {
    xdim[i] = tmp_xdim[i];
    ydim[i] = tmp_ydim[i];
    bmaj[i] = tmp_bmaj[i];
    bmin[i] = tmp_bmin[i];
    beamarea[i] =  tmp_beamarea[i];
    imgnum[i] = tmp_imgnum[i];
    /*
      for(j=0;j<=imgnum[i];j++) {
	frequency[i] = (float *)calloc(totalsize,sizeof(float));
	frequency[i][j] = tmp_frequency[i][j];
	}*/
  }






  // Free up the temporray arrays used
  /*
    for(i=0; i<numdatasets+1; i++) {

    for(j=0;j<=imgnum[i];j++) {
    free(tmp_frequency[i]);
    }*/

  /*free(tmp_xdim);
    free(tmp_ydim);
    free(tmp_bmaj);
    free(tmp_bmin);
    free(tmp_beamarea);
    free(tmp_imgnum);
    //free(tmp_frequency);
    }
  */



  return 0;

}

